/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumOpthalmicSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_VisualFieldProcedureModifier;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_VisualFieldProcedureModifier;


/**
 * This class represents VisualFieldProcedureModifier CID4256
 */
public class VisualFieldProcedureModifier_CID4256 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new VisualFieldProcedureModifier_CID4256 Template 
	 */
	public VisualFieldProcedureModifier_CID4256()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumVisualFieldProcedureModifier Object of EnumCM_VisualFieldProcedureModifier represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_VisualFieldProcedureModifier enumVisualFieldProcedureModifier)
	{
		switch(enumVisualFieldProcedureModifier)
		{
		case SCREENING: this.strCodeValue =EnumCV_VisualFieldProcedureModifier.SCREENING_R_42453.getValue(); break;
		case DIAGNOSTIC: this.strCodeValue =EnumCV_VisualFieldProcedureModifier.DIAGNOSTIC_R_408C3.getValue(); break;

		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumVisualFieldProcedureModifier Object of EnumCM_VisualFieldProcedureModifier represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_VisualFieldProcedureModifier enumVisualFieldProcedureModifier)
	{
		switch(enumVisualFieldProcedureModifier)
		{
		case SCREENING:
			this.strSNOMEDCTID = EnumOpthalmicSNOMEDMap.SCREENING.getSNOMEDCTID();
			break;
		case DIAGNOSTIC:
			this.strSNOMEDCTID = EnumOpthalmicSNOMEDMap.DIAGNOSTIC.getSNOMEDCTID();
			break;
		}
	}

	/**
	 * Sets the value for VisualFieldProcedureModifier
	 * @param enumVisualFieldProcedureModifier Object of EnumCM_VisualFieldProcedureModifier.
	 */
	public void setVisualFieldProcedureModifier(EnumCM_VisualFieldProcedureModifier enumVisualFieldProcedureModifier)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumVisualFieldProcedureModifier.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumVisualFieldProcedureModifier);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumVisualFieldProcedureModifier);
	}
}
